/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pb138.domtest;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class DomTest {
    Document doc=null;
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException, TransformerConfigurationException, TransformerException{
        DomTest domTest=new DomTest("books.xml");
        domTest.changeAuthor("Neznamy","Jan Novak");
        System.out.println("Total pages: " + domTest.countPages());
        domTest.removeOldBooks(1972);
        domTest.addBook("Java efektivne","Joshua Bloch","2005","225");
        domTest.serialize("out.xml");
        
        
    }
   
    public void addBook(String title, String author, String year, String pages) {
        Element authorElement = doc.createElement("author");
        Element titleElement = doc.createElement("title");
        Element pagesElement = doc.createElement("pages");
        Element bookElement = doc.createElement("book");
        
        authorElement.setTextContent(author);
        titleElement.setTextContent(title);
        pagesElement.setTextContent(pages);
        
        bookElement.appendChild(authorElement);
        bookElement.appendChild(titleElement);
        bookElement.appendChild(pagesElement);
        
        NodeList booksList = doc.getElementsByTagName("books");
        boolean added = false;
        
        for(int i = 0; i < booksList.getLength() ; i++){
            Element books = (Element) booksList.item(i);
            
            if(books.getAttribute("year").equals(year)){
                books.appendChild(bookElement);
                added = true;
            }
        }
        
        if( ! added ){
            Element booksElement = doc.createElement("books");
            booksElement.setAttribute("year", year);
            booksElement.appendChild(bookElement);
            doc.getDocumentElement().appendChild(booksElement);
        }
            
    }
/**
 * Counts the total number of pages in the bookshell
 * @return number of pages
 */
    public int countPages(){
        NodeList pageCounts = doc.getElementsByTagName("pages");
        int totalPages = 0;
        
        for(int i = 0 ; i < pageCounts.getLength() ; i++){
        
            Element pages = (Element)pageCounts.item(i);
            totalPages += Integer.parseInt(pages.getTextContent());
        
        }
        
        return totalPages;
    }
            
    /**
     * Changes all occurancies of oldName in the element author to a newName
     * @param oldName original name of the author
     * @param newName new name of the author
     */
    public void changeAuthor(String oldName, String newName) {
        
        NodeList authors= doc.getElementsByTagName("author");
        
        for(int i = 0 ; i < authors.getLength() ; i++ ){
            Element author = (Element)authors.item(i);
            if( author.getTextContent().equals(oldName) ){
                author.setTextContent(newName);
            }
        }
    }
    
    /**
     * Removes books older than minYear
     * @param minYear minimal year of the book to stay in the shell
     */
    
    public void removeOldBooks(int minYear) {
        
        List<Element> booksToBeRemoved = new LinkedList<Element>();
        NodeList books = doc.getElementsByTagName("books");
        
        for(int i = 0 ; i < books.getLength() ; i++){
            
            Element tmpBooks = (Element)books.item(i);
            int booksYear = Integer.parseInt( tmpBooks.getAttribute("year") );
            if( booksYear < minYear ){
                booksToBeRemoved.add(tmpBooks);
            }
            
        }
        
        for ( Element book : booksToBeRemoved ){
            
            doc.getDocumentElement().removeChild(book);
            
        }
    }
    
    public DomTest(String fileName) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory docBuilderFactory=DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder=docBuilderFactory.newDocumentBuilder();
        doc=docBuilder.parse(fileName);
    }

    
    
    public void serialize(String output) throws TransformerConfigurationException, TransformerException{
        TransformerFactory transFact=TransformerFactory.newInstance();
        Transformer transformer=transFact.newTransformer();
        DOMSource domSource=new DOMSource(doc);
        StreamResult stream=new StreamResult(output);
        
        transformer.transform(domSource, stream);
    }

    

    
    
    

}
